#ifndef bqt_rect_hh
#define bqt_rect_hh

#include <algorithm>

class rect
{
	/* sy palasen, olettaa ett tulos on yh suorakulmio */
	const rect eat(const rect &r) const;
public:
	int x1,y1, x2,y2;

	rect() { setempty(); }
	rect(int X1,int Y1, int X2,int Y2) : x1(X1),y1(Y1),x2(X2),y2(Y2)
	{
	}	
	void setempty()
	{
		x1=y1=0;
		x2=y2=-1;
	}
	operator bool() const
	{
		return !(x1>x2 || y1>y2);
	}
	bool operator== (const rect &r) { return x1==r.x1 && x2==r.x2 && y1==r.y1 && y2==r.y2; }
	const rect intersect(const rect &r) const
	{
		if(x2 < r.x1 || r.x2 < x1 || y2 < r.y1 || r.y2 < y1)return rect();
		return rect(max(x1, r.x1), max(y1, r.y1),
		            min(x2, r.x2), min(y2, r.y2));
	}
	/* Tuottaa kaksi boksia, a ja b, jotka eivt sisll
	 * tmn ja vanhan yhteist aluetta
	 */
	void clipboxes(const rect &old, rect &a, rect &b) const;
	rect &move(int x, int y)
	{
		x1+=x; y1+=y;
		x2+=x; y2+=y;
		return *this;
	}
};

#endif
